--[[---------------------------------------------------------------------------

Copyright (c) 2008-2017 by K. Scott Piel 
All Rights Reserved

E-mail: < kscottpiel@gmail.com >

This file is part of nUI.

The author no longer develops or directly supports this addon and has released it
into the public domain under the Creative Commons Attribution-NonCommercial 3.0 
Unported license - a copy of which is included in this distribution. This source
may not be distributed without said license.
	   
nUI is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
PURPOSE.  See the enclosed license for more details.
	
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS  "AS IS" AND 
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT  LIMITED TO, THE IMPLIED 
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.

--]]---------------------------------------------------------------------------

if not ImpliedTarget then
	return
end

-- nUI handles paging for the primary action bar so remove it from ImpliedTarget
ImpliedTarget.DisablePaging()

-- nUI remaps key binds already so remove it from ImpliedTarget
ImpliedTarget.DisableKeyBinding()

local AddButton, RemoveButton = ImpliedTarget.AddButton, ImpliedTarget.RemoveButton

-- nUI makes all new action buttons and hides the defaults so remove them from ImpliedTarget
for id = 1, NUM_ACTIONBAR_BUTTONS do
	RemoveButton('ActionButton' .. id)
	-- RemoveButton('ExtraActionButton' .. id)
	RemoveButton('MultiBarBottomLeftButton' .. id)
	RemoveButton('MultiBarBottomRightButton' .. id)
	RemoveButton('MultiBarLeftButton' .. id)
	RemoveButton('MultiBarRightButton' .. id)
end

for id = 1, NUM_OVERRIDE_BUTTONS or NUM_ACTIONBAR_BUTTONS do
	RemoveButton('OverrideActionBarButton' .. id)
end

local function AddButtons()
    -- Add nUI's action buttons
    for i in pairs(nUI_ButtonBars.Bars) do
        local bar = nUI_ButtonBars.Bars[i]
        for row in pairs( bar.Buttons ) do
            for col in pairs( bar.Buttons[row] ) do
                local button = bar.Buttons[row][col];
                AddButton(button)
            end
        end    
    end
end


local frame = CreateFrame("Frame")
frame:RegisterEvent("PLAYER_LOGIN")
frame:SetScript("OnEvent",function(self,event,...)
    if nUI and ImpliedTarget then
        AddButtons()
    end
end)

